Pr��fen ob ein Layer vorhanden ist / AutoCAD VBA
David F. 26 04. Mai. 2018, 10:10

Guten Morgen liebes Forum,

ich habe, vermutliche eine Simple, Frage.

Ich habe folgenden Code

ThisDrawing.ActiveLayer = ThisDrawing.Layers("ADS_0_Hilfslinie")
    ThisDrawing.SendCommand "PL" & vbCr

Soweit funktioniert er auch.

Wenn ich aber eine neue Zeichnung aufmache möchte ich natürlich erstmal prüfen ob der Layer vorhanden ist.

Wie stelle ich das am Besten an?

cadffm 04. Mai. 2018, 10:46

Ich hätte jetzt gesagt: Layercollection durchlaufen und prüfen oder versuchen auf den Layer aus der Collection zuzugreifen und Fehler abfangen (falls er nicht vorhanden ist).
Da ich aber mit VBA wenig am Hute habe verweise ich mal auf andere Quellen.


Google allgemein www.google.de läßt sich auch als Suchmaschine auf CAD.de nutzen(site
und die Ergebnisse anhand eines Begriffes aus der Boardadresse(Forum259) recht gut filtern.
site:cad.de Forum259 layer vorhanden

nur ein Beispiel: http://ww3.cad.de/foren/ubb/Forum259/HTML/000750.shtml#000000


Hole dir am besten ein AutoCAD-VBA Buch, wenn VBA die angestrebte Sprache ist.
Aber es gibt auch alles im www nachzulesen, natürlich.

Dazu noch die bereits vorhandene Entwickler-HILFE [F1]
Dort findest du auch das ObjektModell und alles weitere.
Beispiel: http://help.autodesk.com/view/OARX/2019/ENU/?guid=GUID-A5B6ACC4-DCD8-4FE2-AB06-D3C3C349475B

Schau doch mal (Weltweit) ob du dieses alte Buch für ein paar Euro bekommst, Klick. Es schadet zumindest nicht.
Dazu ein aktuelles und/oder die OnlineResourcen.

David F. 26 04. Mai. 2018, 10:56

Vielen Dank genau was ich gesucht hatte.

Also ich hier im Forum "Layer vorhanden" Oder "Prüfen ob Layer vorhanden" eingegeben habe bin ich leider nicht auf diese Thema gekommen.

:/

cadffm 04. Mai. 2018, 11:23

Vielleicht hast du es bei FILTER eingetragen und nicht bei SUCHE ?
Jedoch arbeite ich praktisch nie mit der Boardeigenen Suche, außer ich suche Dateianhänge.

Na dann, merke dir site:cad.de und Forum259, oder erstelle dir direkt ein Lesezeichen dafür.

rexxitall 12. Mai. 2018, 20:41

So kann man das lösen.

Function Layer_Exist(ByRef LAYERNAME As String) As Boolean
    Dim objlayer As AcadLayer
    For Each objlayer In thisdrawing.LAYERS
        If UCase(objlayer.Name) = UCase(LAYERNAME) Then
            Layer_Exist = True
            Exit Function
        End If
    Next objlayer
    Layer_Exist = False
   
   
   
   
End Function

Public Function Layer_Exist_fast(LAYERNAME As String) As Boolean
    Dim objlayer As AcadLayer
    Dim objlayers As AcadLayers
    On Error Resume Next
    Set objlayers = thisdrawing.LAYERS
    Set objlayer = objlayers(LAYERNAME)
    Layer_Exist_fast = (ERR.Number = 0)
    ERR.Clear
End Function